from web import views, rpc


URLS = {
    # RPC
    '/rpc/settings/test/': rpc.SettingsTestRPC,
    '/rpc/settings/': rpc.SettingsRPC,
    '/rpc/wallets/(?P<wallet_id>[\d]+)/prepare/': rpc.WalletPrepareRPC,
    '/rpc/wallets/(?P<wallet_id>[\d]+)/label/': rpc.WalletLabelRPC,
    '/rpc/wallets/(?P<wallet_id>[\d]+)/balance/': rpc.WalletBalanceRPC,
    '/rpc/wallets/(?P<wallet_id>[\d]+)/rescan/': rpc.WalletRescanRPC,
    '/rpc/wallets/(?P<wallet_id>[\d]+)/transfers/': rpc.WalletTransfersRPC,
    '/rpc/wallets/(?P<wallet_id>[\d]+)/make/': rpc.WalletMakeRPC,
    '/rpc/wallets/(?P<wallet_id>[\d]+)/exchange/': rpc.WalletExchangeRPC,
    '/rpc/wallets/(?P<wallet_id>[\d]+)/finalize/': rpc.WalletFinalizeRPC,
    '/rpc/wallets/(?P<wallet_id>[\d]+)/export/': rpc.WalletExportInfoRPC,
    '/rpc/wallets/(?P<wallet_id>[\d]+)/import/': rpc.WalletImportInfoRPC,
    '/rpc/wallets/(?P<wallet_id>[\d]+)/tx/show/': rpc.WalletTxShowRPC,
    '/rpc/wallets/(?P<wallet_id>[\d]+)/tx/sign/': rpc.WalletTxSignRPC,
    '/rpc/wallets/(?P<wallet_id>[\d]+)/tx/submit/': rpc.WalletTxSubmitRPC,
    '/rpc/wallets/(?P<wallet_id>[\d]+)/archive/': rpc.WalletArchiveRPC,
    '/rpc/wallets/(?P<wallet_id>[\d]+)/stop/': rpc.WalletStopRPC,
    '/rpc/wallets/(?P<wallet_id>[\d]+)/client/': rpc.WalletRunClientRPC,
    '/rpc/wallets/(?P<wallet_id>[\d]+)/': rpc.WalletDetailRPC,
    '/rpc/wallets/': rpc.WalletListRPC,
# static files, css and js
    '/static/(?P<name>.+)': views.StaticView,
# html
    '/wallets/(?P<wallet_id>[\d]+)/': views.WalletDetailView,
    '/wallets/': views.WalletListView,
    '/': views.HomeView,
}
